/*
 * PM - 2017
 * Statie-Meteo
 * Mihalache Octavian
 * Grupa 332CA
 */


#include <avr/io.h>
#include <util/delay.h>
#include <stdlib.h>
#include <stdio.h>
#include "lcd.h"
#include "bme280.h"

#define LCD_DELAY	200
void lcd_str_helper(char* data){
	int i;
	for (i = 0; i < strlen(data); i++){
		lcd_chr(data[i]);
	}
}

int main(void) {
	struct bme280_t bme280;
	double temp, pres, humidity;
	int32_t t_int, p_int, h_int;

	//bme280_init(&bme280);
	bme280_set_power_mode(BME280_NORMAL_MODE);
	bme280_set_oversamp_pressure(BME280_OVERSAMP_2X);
	bme280_set_oversamp_temperature(BME280_OVERSAMP_4X);
	lcd_init();
	lcd_contrast(0x40);
	char* temp_buff = malloc(sizeof(int) + 2 * sizeof(char));
	char* press_buff = malloc(sizeof(int) + 2 * sizeof(char));

	while(1) {
		lcd_goto_xy(1,1);
		lcd_str("TEMP:");
		lcd_goto_xy(1,2);
		lcd_str("PRESS:");
		lcd_goto_xy(1,3);
		lcd_str("HUM:");

		bme280_read_uncomp_temperature(&t_int);
		t_int = bme280_compensate_temperature_int32(t_int);

		sprintf(temp_buff, "%d C", t_int);
		lcd_goto_xy(6,1);
		lcd_str_helper(temp_buff);

		bme280_read_uncomp_pressure(&p_int);
		p_int = bme280_compensate_pressure_int32(p_int);

		sprintf(press_buff, "%d PA", p_int);
		lcd_goto_xy(7,2);
		lcd_str_helper(press_buff);

		_delay_ms(LCD_DELAY);
		lcd_clear();
	}

	return 0;
}
